Part Part2DObject
Introduction
A Part Part2DObject, or formally a Part::Part2DObject
, is a simple element with a topological shape that can be displayed in the 3D view.
The Part::Part2DObject
is derived from the Part Feature, but is specialized for 2D geometry, given that its shape will lie on a plane. This plane is defined by its Placement property (position, normal, and rotation). However, the plane can also be defined by supporting geometrical elements, such as the plane created by three arbitrary vertices, or a face of a solid body.
Simplified diagram of the relationships between the core objects in FreeCAD
Usage
The Part Part2DObject is an internal object, so it cannot be created from the graphical interface, only from the Python console as described in the Scripting section.
The Part::Part2DObject
is defined in the Part Workbench but can be used as the base class for scripted objects in all workbenches that produce 2D geometrical shapes. For example, it is the base object for sketches (Sketcher SketchObject), and for most objects created with the Draft Workbench.
Workbenches can add more properties to this basic element to produce an object with complex behavior.
Properties
See Property for all property types that scripted objects can have.
The Part Part2DObject (Part::Part2DObject
class) is derived from the Part Feature (Part::Feature
class) and inherits all its properties.
The Part Part2DObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.
Data
{{TitleProperty|Attachment}}
Scripting
See also:
FreeCAD Scripting Basics and scripted objects.
See Part Feature for the general information on adding objects to the document.
A Part2DObject is created with the addObject()
method of the document.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Part::Part2DObject", "Name")
obj.Label = "Custom label"
For Python subclassing you should create a Part::Part2DObjectPython
object.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Part::Part2DObjectPython", "Name")
obj.Label = "Custom label"
⏵ documentation index > Part > Part Part2DObject
This page is retrieved from https://github.com/FreeCAD/FreeCAD-documentation/blob/main/wiki/Part_Part2DObject.md